Subject: Re: MIPS eBPF JIT support on pre-32R2

From: Daniel Borkmann <[email-masked]>
Date: Thu, 5 Dec 2019 14:04:09 +0100

On Thu, Dec 05, 2019 at 03:45:27PM +0300, Alexander Lobakin wrote:
> Hey all,
> 
> I'm writing about lines arch/mips/net/ebpf_jit.c:1806-1807:
> 
> 	if (!prog->jit_requested || MIPS_ISA_REV < 2)
> 		return prog;
> 
> Do pre-32R2 architectures (32R1, maybe even R3000-like) actually support
> this eBPF JIT code? If they do, then the condition 'MIPS_ISA_REV < 2'
> should be removed as it is always true for them and tells CC to remove
> JIT completely.
> 
> If they don't support instructions from this JIT, then the line
> arch/mips/Kconfig:50:
> 
> 	select HAVE_EBPF_JIT if (!CPU_MICROMIPS)
> 
> should be changed to something like:
> 
> 	select HAVE_EBPF_JIT if !CPU_MICROMIPS && TARGET_ISA_REV >= 2
> 
> (and then the mentioned 'if' condition would become redundant)
> 
> At the moment it is possible to build a kernel without both JIT and
> interpreter, but with CONFIG_BPF_SYSCALL=y (what should not be allowed
> I suppose?) within the following configuration:

Cannot comment on the MIPS ISA question above, but it would definiely be
a bug to build a kernel with neither JIT nor interpreter. If a JIT is not
available, then there /must/ be the interpreter as fallback to be able to
run BPF programs.

> - select any pre-32R2 CPU (e.g. CONFIG_CPU_MIPS32_R1);
> - enable CONFIG_BPF_JIT (CONFIG_MIPS_EBPF_JIT will be autoselected);
> - enable CONFIG_BPF_JIT_ALWAYS_ON (this removes BPF interpreter from
>   the system).
> 
> I may prepare a proper patch by myself if needed (after clarification).
> Thanks.
> 
> Regards,
> ᚷ ᛖ ᚢ ᚦ ᚠ ᚱ